var statesQuestionAnswer = function() {

	//for all states data
	var statesArray = [],
		statesArrayLength = statesArray.length,
		statesArray = getStatesData();

	//holds all data needed for questions and answers
	var qAndaObj = {};

	//generate a random number (50 is for states data)
	var randomNumber = function(max){
		max = max || 50;
		return Math.floor(Math.random() * max);
	},

	//make an array of unique random numbers from a range
		randomNumbersArray = function(size,max){
			var numbersArr = [], lengthToReturn = size;

			//watch dat infinite loop, son
			if (size > lengthToReturn) {size = lengthToReturn;}

			while(numbersArr.length < lengthToReturn){
				var random = randomNumber(max);
				if (numbersArr.indexOf(random) > -1) {continue;}
				numbersArr[numbersArr.length] = random;
			}
			return numbersArr;
		},

	//generate random alphanumeric for multiple choice
		randomChars = function(){
			var chars = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ',
				charArr = [],
				randomArr = randomNumbersArray(3,35);

			charArr.push(chars.substring(randomArr[0],randomArr[0]+1));
			charArr.push(chars.substring(randomArr[1],randomArr[1]+1));
			charArr.push(chars.substring(randomArr[2],randomArr[2]+1));

			return charArr;
		},

	//generate question and answers object
		generateQA = function(){

			//reset
			qAndaObj = {
				states: [],
				question: '',
				answers: [],
				correct: {}
			};

			//get random states
			var statesPositions = randomNumbersArray(3,50);
			qAndaObj.states.push(statesArray[statesPositions[0]]);
			qAndaObj.states.push(statesArray[statesPositions[1]]);
			qAndaObj.states.push(statesArray[statesPositions[2]]);

			//select random position in state array randomly, as correct answer
			var correctState = qAndaObj.states[randomNumber(3)],
				state = '';
			for (var prop in correctState) {state = prop; break;}
			qAndaObj.correct = correctState;

			//grab correct answer's capital and nickname
			var stateInfo = correctState[Object.keys(correctState)[0]],
				capital = stateInfo.capital,
				nickname = stateInfo.nickname;

			//populate correct prop object with correct answer
      //there's a better way of capturing the correct answer
      //this is just for the front-end examples
			qAndaObj.correct = correctState;

			//stuff for the answers
			var theCapital = false,
				theState = false,
				theNickname = false,
				answerPropArray = [];

			//determine question verbiage and answers
			switch(randomNumber(4)) {
				case 0:
					qAndaObj.question = 'What is the capital of ' + state + '?';
					theCapital = true;
					break;
				case 1:
					qAndaObj.question = capital + ' is the capital of what state?';
					theState = true;
					break;
				case 2:
					qAndaObj.question = 'What is ' + state + '\'s nickname?';
					theNickname = true;
					break;
				case 3:
					qAndaObj.question = 'What state is nicknamed "' + nickname + '"?';
					theState = true;
					break;
			}

			//construct the answer strings
			for (i=0; i<3; i++){
				var thinger = qAndaObj.states[i]; //got annoyed with naming variables at this point
				if (theCapital) {
					answerPropArray.push(thinger[Object.keys(thinger)[0]].capital);
				}
				else if (theState) {
					for (var prop in qAndaObj.states[i]) {
						answerPropArray.push(prop);
						break;
					}
				}
				else if (theNickname) {
					answerPropArray.push(thinger[Object.keys(thinger)[0]].nickname);
				}
			}

			var charsForAnswers = randomChars();
			qAndaObj.answers.push('PRESS ' + charsForAnswers[0] + ' for ' + answerPropArray[0]);
			qAndaObj.answers.push('PRESS ' + charsForAnswers[1] + ' for ' + answerPropArray[1]);
			qAndaObj.answers.push('PRESS ' + charsForAnswers[2] + ' for ' + answerPropArray[2]);

			return qAndaObj;

		}
	return generateQA();
};
